﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestCS
{
    /// <summary>
    /// 必须加这一行，内部使用
    /// </summary>
    [ToolboxItem(true)]

    public partial class UserControl1 : UserControl
    {
        public int handle;
        public UserControl1()
        {
            InitializeComponent();
        }
        bool A = false;
        private void Connect_Click(object sender, EventArgs e)
        {
            if (A == false)
            {
                string ip = "127.0.0.1";
                char[] ip1 = ip.ToCharArray();
                handle = YKApi.Connect(ip1, 502);
                if (handle < 0)
                    Connect.Text = "连接失败";
                else
                    Connect.Text = "已成功连接，点击退出";

                A = true;
            }
            else
            {
                string ip = "127.0.0.1";
                char[] ip1 = ip.ToCharArray();
                handle = YKApi.Close(handle);
                handle = 0;
                Connect.Text = "已退出连接，点击连接";
                A = false;
            }

        }

        private void RD0D1_Click(object sender, EventArgs e)
        {
            ushort[] data = new ushort [2];
            char[] a = new char[20];
            float fv = 0;
            if (handle >= 0)
            {
                //读取D的值
                MyEnum ret = YKApi.ReadWordD(handle, 0, 2, data);
                textEdit te = new textEdit(); 
                if (ret == MyEnum.ERR_OK)
                {
                    te.text = "读取成功";

                    //分成三种显示方式 // 16位
                    d016.Value = data[0];
                    D116.Value = data[1];

                    //32位
                    D032.Value = (int)(data[1] << 16) | data[0];

                    //浮点显示
                    YKApi.WordToFloat(data, ref fv);
                    D0fudian.Value = (decimal)fv;
                }
                else
                {
                    te.text = "读取失败";
                }
                te.Show();
            }
        }

        private void WD0_16_Click(object sender, EventArgs e)
        {
            ushort[] data = new ushort[2];

            if (handle >= 0)
            {
                data[0] = (ushort)D016w.Value;
                data[1] = (ushort)D116w.Value;
                MyEnum ret = YKApi.WriteWordD(handle, 0, 2, data);
   
                textEdit te = new textEdit();   
                if (ret == MyEnum.ERR_OK)
                {
                    te.text = "写入成功";
                }
                else
                {
                    te.text = "写入失败";
                }
                te.Show();
            }
        }

        private void WD0_32_Click(object sender, EventArgs e)
        {
            ushort[] data = new ushort[2];

            if (handle >= 0)
            {
                int dat = (int)d032w.Value;
                //32位拆成两个16位
                data[0] = (ushort)dat;
                data[1] = (ushort)(dat >> 16);
                MyEnum ret = YKApi.WriteWordD(handle, 0, 2, data);
                textEdit te = new textEdit();  
                if (ret == MyEnum.ERR_OK)
                {
                    te.text = "写入成功";
                }
                else
                {
                    te.text = "写入失败";
                }
                te.Show();
            }
        }

        private void WD0_F_Click(object sender, EventArgs e)
        {
            ushort[] data = new ushort[2];
         
            if (handle >= 0)
            {
                float FV = (float)d032fudian.Value;
                //浮点转换成ushort
                YKApi.FloatToWord(FV, data);

                MyEnum ret = YKApi.WriteWordD(handle, 0, 2, data);
                textEdit te = new textEdit();
                if (ret == MyEnum.ERR_OK)
                {
                    te.text = "写入成功";
                }
                else
                {
                    te.text = "写入失败";
                }
                te.Show();
            }
        }

#region 控件属性
        /// <summary>
        /// 增加控件属性，可在ProU上设置
        /// </summary>
        private Color backcolor1;
        [Category("外观"), DisplayName("背景色On"), Description("背景色变量为ON时的颜色")]
        public Color bk1
        {
            get { return backcolor1; }
            set { backcolor1 = value; }
        }

        private Color backcolor2;
        [Category("外观"), DisplayName("背景色OFF"), Description("背景色变量为OFF时的颜色")]
        public Color bk2
        {
            get { return backcolor2; }
            set { backcolor2 = value; }
        }

        /// <summary>
        /// 增加属性接口，把ProU的变量加载到控件中
        /// </summary>
        private String axis_addr = "";
        [Category("数据"), DisplayName("轴地址变量"), Description("轴地址")]
        public String lible1
        {
            get { return axis_addr; }
            set { axis_addr = value; }
        }

        private String axis_addr1 = "";
        [Category("数据"), DisplayName("轴地址变量"), Description("轴地址")]
        public String lible2
        {
            get { return axis_addr1; }
            set { axis_addr1 = value; }
        }
        #endregion
    }
}
